﻿hex_width = 25;
hex_height = 26;
hshift = (hex_width-1)/2;

function MapRenderer(cont_el_p, map_p)
{
	this.container = $('#'+cont_el_p);
	this.context;
	this.map = map_p;
}

MapRenderer.prototype.init = function()
{
	$("#canva").remove();
	this.container.append
	($(
		"<canvas id=canva></canvas>"
	));
	var canvas = document.getElementById('canva');
	if(canvas)
	{
		var hx = this.map.hex_count_x;
		var hy = this.map.hex_count_y;
		canvas.setAttribute("width", hex_width * hx + 30 - hx);
		canvas.setAttribute("height", hex_height* hy + 30 - hy*8);
	}
	if(!canvas.getContext)
	{
		alert("Данный браузер не поддерживает работу с канвой.");
		return false;
	}
	this.context = canvas.getContext("2d");
	this.context.font = "bold 10px Arial";
	this.context.textAlign = "center";
	this.context.strokeStyle = "black";
	return true;
}

MapRenderer.prototype.draw = function()
{
	if(this.init())
	{
		var bm = this.map;
		var hx = bm.hex_count_x;
		var hy = bm.hex_count_y;
		
		for(var y=0;y<hy;y++) for(var x=0;x<hx;x++) 
		{
			var hs = 10;
			if(y % 2 == 0) hs = 0; 
			else hs = hshift;
			this.draw_hexagon(10 + x*24 + hs, 21 + y*18 - hshift, bm.map[y][x]);
			//this.draw_hexagon(10 + x*30 + hs, 21 + y*30 - hshift, bm.map[y][x]);
		}
	}
}

MapRenderer.prototype.draw_line = function(x0,y0,x1,y1,w,c)
{
	var ct = this.context;
	if(ct)
	{
		ct.strokeStyle = c;
		ct.beginPath(); 
		ct.moveTo(x0,y0); 
		ct.lineTo(x1,y1);
		ct.lineWidth = w;
		ct.stroke();
	}
}

MapRenderer.prototype.draw_hexagon = function(pos0x, pos0y, hexagon_obj)
{
	var ho = hexagon_obj;
	var x0 = pos0x;
	var y0 = pos0y;
	var ct = this.context;
	
	if(ct)
	{
		ct.fillStyle = ho.get_rgb();
		
		ct.beginPath();
		ct.moveTo(x0+12,y0);
		ct.lineTo(x0+24,y0+6);
		ct.lineTo(x0+24,y0+19);
		ct.lineTo(x0+12,y0+25);
		ct.lineTo(x0,y0+19);
		ct.lineTo(x0,y0+6);
		ct.fill();
		
		this.draw_line(x0+12,y0,x0+24,y0+6,ho.get_face_in(0),ho.get_face_color(0));
		this.draw_line(x0+24,y0+6,x0+24,y0+19,ho.get_face_in(1),ho.get_face_color(1));
		this.draw_line(x0+24,y0+19,x0+12,y0+25,ho.get_face_in(2),ho.get_face_color(2));
		this.draw_line(x0+12,y0+25,x0,y0+19,ho.get_face_in(3),ho.get_face_color(3));
		this.draw_line(x0,y0+19,x0,y0+6,ho.get_face_in(4),ho.get_face_color(4));
		this.draw_line(x0,y0+6,x0+12,y0+0,ho.get_face_in(5),ho.get_face_color(5));
		
		if(ho.height!=0)
		{
			ct.fillStyle = ho.get_inverted_bicolor();
			ct.fillText(ho.height, x0+12, y0+15);
		}
	}
}
